eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
     & eval 'exec perl -S $0 $argv:q'
     if 0;

# -*- perl -*-

use Sys::Hostname;
use lib "$ENV{ACE_ROOT}/bin";
use lib "$ENV{DDS_ROOT}/bin";
use PerlDDS::Run_Test;
use strict;

my $dcpsrepo_ior = "repo.ior";
unlink $dcpsrepo_ior;

my $DCPSREPO = PerlDDS::create_process("$ENV{DDS_ROOT}/bin/DCPSInfoRepo",
                                       "-NOBITS -o $dcpsrepo_ior");

$DCPSREPO->Spawn ();
if (PerlACE::waitforfile_timed($dcpsrepo_ior, 30) == -1) {
    print STDERR "ERROR: waiting for DCPSInfo IOR file\n";
    $DCPSREPO->Kill();
    exit 1;
}

my $opts = '';
my $iter = 1;
my $nint = 1;

while (scalar @ARGV) {
  if ($ARGV[0] =~ /^-d/i) {
    shift;
    # " -DCPSTransportDebugLevel 6 -DCPSDebugLevel 10 -ORBLogFile log.txt";
    $opts .= " -DCPSTransportDebugLevel 4 -DCPSDebugLevel 8 -ORBLogFile log.txt";
  }
  elsif ($ARGV[0] =~ m/^-i(\d+)/) {
      $iter = $1;
      shift;
  }
  elsif ($ARGV[0] =~ m/^-n(\d+)/) {
      $nint = $1;
      shift;
  }
  elsif ($ARGV[0] eq 'nopub') {
    shift;
    $opts .= " -DCPSPublisherContentFilter 0";
  }
}


my @machines = ( 
    "lab01", "lab02", "lab03", "lab04", "lab05", 
    "lab06", "lab07", "lab08", "lab09", "lab10",
    "lab11", "lab12", "lab13", "lab14", "lab15",
    "lab16", "lab17");

my $host = hostname;
my $rank;
my @procs = ();
my $size=scalar(@machines);
for ($rank=0; $rank<$size; $rank++) {
    my $sizerank = " -s $size -r $rank -i $iter -n $nint";

    my $cmd;
    my $cmdargs;

    if ($machines[$rank] eq $host) {
	$cmd = '../Output/Release/labtest.sh';  #DDSMPI
	$cmdargs = "-DCPSConfigFile ../DDSMPI/dcps.ini ". 
	    $opts . $sizerank . "\n";
    }
    else {
	my $path = '/share/student/calkinsc/MPI';
	$cmd = '/usr/bin/ssh';
	$cmdargs = "$machines[$rank] $path/Output/Release/labtest.sh " .
	    "-DCPSConfigFile $path/DDSMPI/dcps.ini " .
	    "-DCPSInfoRepo file://$path/Tests/repo.ior " . 
	    $opts . $sizerank . "\n";
    }

    print $cmd . " -> " . $cmdargs . "\n";

    my $proc = PerlDDS::create_process($cmd, $cmdargs);
    $proc->Spawn();
    push(@procs, $proc);
}

for ($rank=0; $rank<$size; $rank++) {
    $procs[$rank]->WaitKill(600);
}

$DCPSREPO->TerminateWaitKill(5);

# exit (($result == 0) ? 0 : 1);
exit 0;
